#ifndef HEXAGONO_H
#define HEXAGONO_H
#include <iostream>
#include <exception>

using namespace std;

// Classe abstrata que implementa os metodos e a estrutura geral de todo hexagono em um mapa hexagonal.
// Implementado com base em     https://www.redblobgames.com/grids/hexagons/
// Agradeco profundamente 'a equipe RedBlob por disponibilizar isso na internet.
class Hexagono {
    // Metodos publicos: getters e setters
    public:
        Hexagono(float size, bool modo); // Construtor
        ~Hexagono(); // Destrutor

        // Metodos meio inuteis
        float getSize();    
        float getWidth();
        float getHeight(); 
        
        void setMode(bool mode); // 0: "Flat-Topped" 1: "Pointy-Topped"
        void setSize(float size);
    protected:
        void updateRadius();
        
        const float sqrt3 = 1.73205080757; // Aproximacao da raiz de 3 para nao ter de calcular toda vez.
        float size; // Distancia entre o centro e uma ponta do Hexagono. Tambem chamado de circumraio do hexagono.
        float maxRadius; // 2*size
        float minRadius; // sqrt3*size
        

        bool mode;
    private:
        
};
#endif
