#include "Tile.h"
#define MAX_INT 2147483647


Tile::Tile(float size, bool modo, char simbolo, Colors* colormap) : Hexagono(size, modo), simbolo (simbolo), colormap (colormap) {
    for(int i = 0; i < 6; i++) adjacentes[i] = NULL;
    this->coords[0] = MAX_INT;
    this->coords[1] = MAX_INT;
    this->revelado = 0;
    this->marcado = 0;
    this->id[0],this->id[1],this->id[2] = 1;    
};
char Tile::getSimbolo(){
    return simbolo;
}

void Tile::alternaRevela(){
    this->revelado = !(this->revelado);
};

void Tile::alternaMarcado(){
    this->marcado = !(this->marcado);
}

bool Tile::isRevelado(){
    return this->revelado;
};

void Tile::showStatus(){
    // if (this->ocupado){
    // unused
    // }else{}
    if(this->revelado) {
        if (this->marcado) cout << this->colormap->knMark << this->simbolo << this->colormap->reset;
        else cout << this->colormap->kn << this->simbolo << this->colormap->reset;
    }
    else {
        if(this->marcado) cout << this->colormap->unknMark << this->simbolo << this->colormap->reset;
        else cout << this->colormap->unkn << this->simbolo << this->colormap->reset;
    }
}

void Tile::setCoords(int r, int q){
    this->coords[0] = r;
    this->coords[1] = q;
}

int* Tile::getCoords(){
    int* fauxCoords = coords;
    return fauxCoords;
}

void Tile::setAdjacencia(int index, Tile* adjacente){
    if(index > 6 || index < 0 ) {
        // cout << "Fez cagada, volte duas casas" << endl; // DELETAR
        return;
    }
    
    if (adjacente != NULL){
        if(adjacentes[index] != adjacente){
        /* DEBUG
        cout << '[' << index << ',';
        adjacente->showStatus();
        cout << ']' << " ";
        */
        // Torna "A" adjacente a "B"
        adjacentes[index] = adjacente;

        // Torna "B" adjacente a "A" na direcao oposta
        int contraIndex = -1;
        if(index > 2) contraIndex = index - 3;
        else contraIndex = index + 3;
        adjacente->setAdjacencia(contraIndex, this);
        }
    }

}

Tile* Tile::getAdjacente(int index){
    return adjacentes[index];
}

void Tile::imprimeADireita(bool imprimeSelf){
    if(imprimeSelf){
        this->showStatus();
        if(this->adjacentes[2] != NULL) adjacentes[2]->imprimeADireita(!imprimeSelf);
        else if(this->adjacentes[1] != NULL) adjacentes[1]->imprimeADireita(!imprimeSelf);
    }else{
        cout << "\t\t";
        if(this->adjacentes[1] != NULL) adjacentes[1]->imprimeADireita(!imprimeSelf);
    }

}
Tile::~Tile(){
};