#ifndef TILE_H
#define TILE_H
#include "Hexagono.h"
#include "..\Utils\Colors.h"
// static void populate(string file);
// static NomeDaEstrutura;


class Tile : public Hexagono{
    public:
        // Dois primeiros argumentos inconsequentes por enquanto.
        // Simbolo "representa" a tile ao printar
        // colormap define as cores a serem utilizadas para os estados
        Tile(float size, bool modo, char simbolo, Colors* colormap);
        // Tile();
        ~Tile();
        
        // Alternancia de estados (toggle)
        void alternaRevela();
        void alternaMarcado();

        bool isRevelado();
        char getSimbolo();

        // Imprime o simbolo colorido pelo colormap com base no estado
        void showStatus();

        // Retorna as coordenadas (r,q) da tile
        int* getCoords();

        // Define as coordenadas (r,q) da tile
        void setCoords(int r, int q);
        void imprimeADireita(bool imprimeSelf); // deletavel

        // Cria adjacencia com base nesses indices:
        //     _0_
        //  5 /   \ 1
        //  4 \___/ 2 
        //      3
        void setAdjacencia(int index, Tile* adjacente);

        // Retorna o adjacente em uma direcao
        Tile* getAdjacente(int index);
    protected:
        int coords[2];
        Tile* adjacentes[6];
        bool revelado;
        char simbolo;
        bool marcado;
        bool id[3]; // unused
        Colors* colormap;
};
#endif